/*
Copyright 2015, Yahoo Inc. 
Copyrights licensed under the New BSD License.
See the accompanying LICENSE file for terms.
*/

// The tags and attributes listed here are based on http://facebook.github.io/react/docs/tags-and-attributes.html

exports.WhiteListTags = [
    "a",
    "abbr",
    "address",
    "area",
    "article",
    "aside",
    "audio",
    "b",
    "base",
    "bdi",
    "bdo",
    "big",
    "blockquote",
    "body",
    "br",
    "button",
    "canvas",
    "caption",
    "cite",
    "code",
    "col",
    "colgroup",
    "data",
    "datalist",
    "dd",
    "del",
    "details",
    "dfn",
    "dialog",
    "div",
    "dl",
    "dt",
    "em",
    "embed",
    "fieldset",
    "figcaption",
    "figure",
    "footer",
    "form",
    "h1",
    "h2",
    "h3",
    "h4",
    "h5",
    "h6",
    "head",
    "header",
    "hr",
    "html",
    "i",
    "iframe",
    "img",
    "input",
    "ins",
    "kbd",
    "keygen",
    "label",
    "legend",
    "li",
    "link",
    "main",
    "map",
    "mark",
    "menu",
    "menuitem",
    "meta",
    "meter",
    "nav",
    "noscript",
    "object",
    "ol",
    "optgroup",
    "option",
    "output",
    "p",
    "param",
    "picture",
    "pre",
    "progress",
    "q",
    "rp",
    "rt",
    "ruby",
    "s",
    "samp",
    "section",
    "select",
    "small",
    "source",
    "span",
    "strong",
    "sub",
    "summary",
    "sup",
    "table",
    "tbody",
    "td",
    "textarea",
    "tfoot",
    "th",
    "thead",
    "time",
    "title",
    "tr",
    "track",
    "u",
    "ul",
    "var",
    "video",
    "wbr"
];

exports.WhiteListAttributes = [
    "acceptcharset",
    "accesskey",
    "allowfullscreen",
    "allowtransparency",
    "alt",
    "async",
    "autocomplete",
    "autofocus",
    "autoplay",
    "cellpadding",
    "cellspacing",
    "charset",
    "checked",
    "classname",
    "cols",
    "colspan",
    "content",
    "contenteditable",
    "contextmenu",
    "controls",
    "coords",
    "crossorigin",
    "data",
    "datetime",
    "defer",
    "dir",
    "disabled",
    "download",
    "draggable",
    "enctype",
    "form",
    "formenctype",
    "formmethod",
    "formnovalidate",
    "formtarget",
    "frameborder",
    "height",
    "hidden",
    "hreflang",
    "htmlfor",
    "httpequiv",
    "id",
    "label",
    "lang",
    "list",
    "loop",
    "marginheight",
    "marginwidth",
    "max",
    "maxlength",
    "media",
    "mediagroup",
    "method",
    "min",
    "multiple",
    "muted",
    "name",
    "novalidate",
    "open",
    "pattern",
    "placeholder",
    "preload",
    "radiogroup",
    "readonly",
    "rel",
    "required",
    "role",
    "rows",
    "rowspan",
    "sandbox",
    "scope",
    "scrolling",
    "seamless",
    "selected",
    "shape",
    "size",
    "sizes",
    "span",
    "spellcheck",
    "srcdoc",
    "srcset",
    "start",
    "step",
    "tabindex",
    "target",
    "title",
    "type",
    "value",
    "width",
    "wmode",

    "style",
    
    /* href attributes */
    "action",
    "background",
    "codebase",
    "cite",
    "classid",
    "folder",
    "formaction",
    "href",
    "icon",
    "longdesc",
    "manifest",
    "poster",
    "profile",
    "src",
    "usemap",
    "xlink:href",
    "xml:base",
    "xmlns",
    "xmlns:xlink"
];

// TODO: replace the following with CP.getAttributeType() as in https://github.com/yahoo/secure-handlebars/blob/master/src/parser-utils.js#L82
exports.HrefAttributes = {
    "action":1,
    "background":1,
    "codebase":1,
    "cite":1,
    "classid":1,
    "folder":1,
    "formaction":1,
    "href":1,
    "icon":1,
    "longdesc":1,
    "manifest":1,
    "poster":1,
    "profile":1,
    "src":1,
    "usemap":1,
    "xlink:href":1,
    "xml:base":1,
    "xmlns":1,
    "xmlns:xlink":1
};

// Void elements only have a start tag; end tags must not be specified for void elements.
// https://html.spec.whatwg.org/multipage/syntax.html#void-elements
exports.VoidElements = {"area":1, "base":1, "br":1, "col":1, "embed":1, "hr":1, "img":1, "input":1, "keygen":1, "link":1, "menuitem":1, "meta":1, "param":1, "source":1, "track":1, "wbr":1};
